using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.Text;
namespace PHS
{
    /// <summary>
    /// This window wrapper class is used by the AboutPlugIn method.
    /// </summary>
    public class WindowWrapper : IWin32Window
    {
        public WindowWrapper(Int32 handle)
        {
            _hwnd = handle;
        }
        public IntPtr Handle
        {
            get
            {
                return (IntPtr) _hwnd;
            }
        }
        readonly Int32 _hwnd;
    }

    /// <summary>
    /// This class is used by the plugin when it's copied to the MSIcode window or edited afterwards.
    /// </summary>
    [ComVisible(true), Guid("E0441947-2707-41FF-AAB8-12637C83CD7E")]
    public class Ide
    {
        public string ModuleFolder
        {
            get;
            set;
        }

        public int DesignTimeEdit(uint window, string state, ref string newState, bool displayDialog)
        {
            Methods m = new Methods();
            return m.DesignTimeEdit(window, state, ref newState, displayDialog);
        }

        public int DesignTimeText(string state, ref string text)
        {
            Methods m = new Methods();
            return m.DesignTimeText(state, ref text);
        }

        public void AboutPlugIn(Int32 window)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("An InstallAware Dotnet plugin that gets all MAC addresses for controllers whose status is reported as up and running.");
            sb.AppendLine();
            sb.Append("Created by Peter Hamilton-Scott (December 2014)");
            MessageBox.Show(new WindowWrapper(window), sb.ToString(), "MAC addresses plugin", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        public bool CompileTimeBuild(Int32 msiHandle, string state, string buildPath, bool build, ref string fetch)
        {
            Methods m = new Methods();
            return m.CompileTimeBuild(ModuleFolder, msiHandle, state, buildPath, build, ref fetch);
        }
    }
}
